/*##COPYRIGHT
 ***********************************************************************
 *       Copyright (C) 2003, by iAnywhere Solutions, Inc.              *
 *       All rights reserved. iAnywhere Solutions is a trademark       *
 *       of Sybase, Inc.  No part of this software may be              *
 *       reproduced in any form or by any means - graphic,             *
 *       electronic or mechanical, including photocopying,             *
 *       recording, taping or information storage and retrieval        *
 *       systems - except with the written permission of               *
 *       iAnywhere Solutions, Inc.                                     *
 *                                                                     *
 ***********************************************************************
#*/

package ianywhere.demo;

/**
 * Created by iAnywhere Solutions
 * User: huojun
 * Date: 8-May-2003
 * Time: 11:29:50 PM
 */
import org.apache.soap.util.xml.Deserializer;
import org.apache.soap.util.xml.QName;
import org.apache.soap.util.xml.XMLJavaMappingRegistry;
import org.apache.soap.util.Bean;
import org.apache.soap.rpc.SOAPContext;
import org.w3c.dom.Node;

/**
 * This class is designed for APACHE SOAP API to
 * deserialize the SOAP response from ASA 9. Please
 * see APACHE SOAP document for more information.
 */
public class SQLRowSetDeserializer implements Deserializer {
    private SQLRowSet _rowSet = new SQLRowSet();
    private Bean _bean = new Bean(SQLRowSet.class, _rowSet);
    private static final String LOCAL_NAME_SQLROWSET = "sqlrowset";
    private static final String LOCAL_NAME_SQLCODE = "sqlcode";

    /**
     * Unmarshall SOAP response, see APACHE SOAP API doc for
     * details
     * @param s
     * @param qName
     * @param node
     * @param xmlJavaMappingRegistry
     * @param soapContext
     * @return the unmarshall result
     * @throws IllegalArgumentException
     */
    public Bean unmarshall(
            String s,
            QName qName,
            Node node,
            XMLJavaMappingRegistry xmlJavaMappingRegistry,
            SOAPContext soapContext) throws IllegalArgumentException {
        System.out.println("LocalPart = " + qName.getLocalPart());
        System.out.println("NamespaceURI = " + qName.getNamespaceURI());
        String localPart = qName.getLocalPart().toLowerCase();

        // unmarshall the SQLROWSET part in the response
        if (localPart.endsWith(LOCAL_NAME_SQLROWSET)) {
            try {
                _rowSet.setRowSet(node);
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        // unmarshall the sqlcode part in the response
        if (localPart.endsWith(LOCAL_NAME_SQLCODE)) {
            try {
                _rowSet.setSqlCode(node);
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        return _bean;
    }
}
