/*##COPYRIGHT
 ***********************************************************************
 *       Copyright (C) 2003, by iAnywhere Solutions, Inc.              *
 *       All rights reserved. iAnywhere Solutions is a trademark       *
 *       of Sybase, Inc.  No part of this software may be              *
 *       reproduced in any form or by any means - graphic,             *
 *       electronic or mechanical, including photocopying,             *
 *       recording, taping or information storage and retrieval        *
 *       systems - except with the written permission of               *
 *       iAnywhere Solutions, Inc.                                     *
 *                                                                     *
 ***********************************************************************
#*/

package ianywhere.demo.proxy;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.Socket;

/**
 * Created by iAnywhere Solutions
 * User: huojun
 * Date: 27-Mar-2003
 * Time: 6:18:02 PM
 */
public class WorkerThread implements Runnable, Controllable {
    private Proxy _proxy;
    private String _redirectHost;
    private int _redirectPort;
    private boolean _incoming = false;
    private Socket _rwSocket;
    private Socket _wrSocket;
//    private static final String SOAPACTION_HEADER = "SOAPAction";

    public WorkerThread(Proxy proxy, Socket rwSocket, Socket wrSocket) {
        _proxy = proxy;
        _rwSocket = rwSocket;
        _wrSocket = wrSocket;
    }

    public String getRedirectHost() {
        return _redirectHost;
    }

    public void setRedirectHost(String redirectHost) {
        _redirectHost = redirectHost;
    }

    public int getRedirectPort() {
        return _redirectPort;
    }

    public boolean isIncoming() {
        return _incoming;
    }

    public void setIncoming(boolean incoming) {
        _incoming = incoming;
    }

    public void setRedirectPort(int redirectPort) {
        _redirectPort = redirectPort;
    }

    public void start() {
        Thread t = new Thread(this);
        t.start();
    }

    public void shutdown() {
        try {
            _rwSocket.close();
        } catch (IOException ignore) {
        }
        try {
            _wrSocket.close();
        } catch (IOException ignore) {
        }
    }

    public void run() {
        byte[] buf = new byte[1024];
        try {
            InputStream inputStream = _rwSocket.getInputStream();
            OutputStream outputStream = _wrSocket.getOutputStream();
            while (true) {
                int bc = inputStream.read(buf);
                if (bc >= 0) {
                    String s = new String(buf, 0, bc);
                    if(isIncoming()) {
                        if (s.startsWith("POST")) {
                            _proxy.logn("\n\n------------ SOAP REQUEST -----------");
                        }
                    } else {
                        if (s.startsWith("HTTP/")) {
                            _proxy.logn("\n\n------------ SOAP RESPONSE ------------");
                        }
                    }
                    _proxy.log(s);
//                    if (isIncoming()) {
//                        s = updateSOAPAction(s);
//                        System.out.print("new Request: " + s);
//                    }
                    outputStream.write(s.getBytes());
                    outputStream.flush();
                } else {
                    if(!isIncoming()) {
                        break;
                    }
                }
            }
        } catch (IOException e) {
        } finally {
            try {
                _rwSocket.close();
            } catch (IOException ignore) {
            }
            try {
                _wrSocket.close();
            } catch (IOException ignore) {
            }
        }
    }

//    private String updateSOAPAction(String request) throws MalformedURLException {
//        StringBuffer sb = new StringBuffer();
//        StringTokenizer st = new StringTokenizer(request, "\n", true);
//        while (st.hasMoreTokens()) {
//            String s = st.nextToken();
//            if (s.indexOf(SOAPACTION_HEADER) >= 0) {
//                int begin = s.indexOf('"');
//                int end = s.lastIndexOf('"');
//                String urlStr = s.substring(begin + 1, end);
//                URL url = new URL(urlStr);
//                url = new URL(url.getProtocol(), getRedirectHost(), getRedirectPort(), url.getFile());
//                System.out.println("url = " + url);
//                sb.append(SOAPACTION_HEADER);
//                sb.append(": ");
//                sb.append("\"");
//                sb.append(url);
//                sb.append('"');
//            } else {
//                sb.append(s);
//            }
//        }
//        return sb.toString();
//    }
}
