/*##COPYRIGHT
 ***********************************************************************
 *       Copyright (C) 2003, by iAnywhere Solutions, Inc.              *
 *       All rights reserved. iAnywhere Solutions is a trademark       *
 *       of Sybase, Inc.  No part of this software may be              *
 *       reproduced in any form or by any means - graphic,             *
 *       electronic or mechanical, including photocopying,             *
 *       recording, taping or information storage and retrieval        *
 *       systems - except with the written permission of               *
 *       iAnywhere Solutions, Inc.                                     *
 *                                                                     *
 ***********************************************************************
#*/

package ianywhere.demo.types;
/**
 * Created by iAnywhere Solutions
 * User: huojun
 * Date: 27-Mar-2003
 * Time: 2:35:29 PM
 */
import ianywhere.demo.ui.Application;
import ianywhere.demo.ISoapServices;

/**
 * Class to represent a customer, the
 * property names are same as database
 * table column names.
 */
public class Customer {
    public String phone,
    lname,
    fname,
    address,
    state,
    company_name,
    zip,
    city,
    id,
    token;

    private static Customer[] _customers = null;

    public boolean isValidCustomer() {
        if (fname.length() == 0 || lname.length() == 0
                || address.length() == 0 || city.length() == 0
                || phone.length() == 0 || zip.length() == 0
                || company_name.length() == 0) {
            return false;
        }
        return true;
    }

    public String getPhone() {
        return phone;
    }

    public void setPhone(String phone) {
        this.phone = phone;
    }

    public String getLname() {
        return lname;
    }

    public void setLname(String lname) {
        this.lname = lname;
    }

    public String getFname() {
        return fname;
    }

    public void setFname(String fname) {
        this.fname = fname;
    }

    public String getAddress() {
        return address;
    }

    public void setAddress(String address) {
        this.address = address;
    }

    public String getState() {
        return state;
    }

    public void setState(String state) {
        this.state = state;
    }

    public String getCompany_name() {
        return company_name;
    }

    public void setCompany_name(String company_name) {
        this.company_name = company_name;
    }

    public String getZip() {
        return zip;
    }

    public void setZip(String zip) {
        this.zip = zip;
    }

    public String getCity() {
        return city;
    }

    public void setCity(String city) {
        this.city = city;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getToken() {
        return token;
    }

    public void setToken(String token) {
        this.token = token;
    }

    public String toString() {
        return getCompany_name();
    }

    public static void resetCustomerList() {
        _customers = null;
    }

    public static Customer[] getCustomers() throws Exception {
        if (null == _customers) {
            ISoapServices sc = Application.getInstance().getSoapClient();
            _customers = sc.getCustomers();
        }
        return _customers;
    }

    public static Customer getCustomer(String cust_id) throws Exception {
        Customer[] customers = getCustomers();
        for (int i = 0; i < customers.length; i++) {
            Customer customer = customers[i];
            if (customer.id.equalsIgnoreCase(cust_id)) {
                return customer;
            }
        }
        return null;
    }

    public static void addCustomer(Customer customer) throws Exception {
        ISoapServices sc = Application.getInstance().getSoapClient();
        sc.addCustomer(customer);
    }

    public static void updateCustomer(Customer customer) throws Exception {
        ISoapServices sc = Application.getInstance().getSoapClient();
        sc.updateCustomer(customer);
    }

    public boolean equals(Object obj) {
        if (obj instanceof Customer) {
            Customer customer = (Customer) obj;
            return this.getId().equalsIgnoreCase(customer.id);
        }
        return false;
    }
}
