/*##COPYRIGHT
 ***********************************************************************
 *       Copyright (C) 2003, by iAnywhere Solutions, Inc.              *
 *       All rights reserved. iAnywhere Solutions is a trademark       *
 *       of Sybase, Inc.  No part of this software may be              *
 *       reproduced in any form or by any means - graphic,             *
 *       electronic or mechanical, including photocopying,             *
 *       recording, taping or information storage and retrieval        *
 *       systems - except with the written permission of               *
 *       iAnywhere Solutions, Inc.                                     *
 *                                                                     *
 ***********************************************************************
#*/

package ianywhere.demo.types;

/**
 * Class to represent an employee, the
 * property names are same as database
 * table column names.
 */
public class Employee {
    public String phone,
        birth_date,
        bene_life_ins,
        emp_fname,
        street,
        emp_id,
        ss_number,
        dept_id,
        status,
        salary,
        sex,
        emp_lname,
        termination_date,
        state,
        bene_day_care,
        start_date,
        manager_id,
        bene_health_ins,
        city,
        token,
        zip_code;

    /**
     * Get phone number
     * @return phone number
     */
    public String getPhone() {
        return phone;
    }

    /**
     * Set phone number
     * @param phone
     */
    public void setPhone(String phone) {
        this.phone = phone;
    }

    /**
     * Get birthday
     * @return birthday
     */
    public String getBirth_date() {
        return birth_date;
    }

    /**
     * Set birthday
     * @param birth_date
     */
    public void setBirth_date(String birth_date) {
        this.birth_date = birth_date;
    }

    /**
     * Get bene_life_ins
     * @return bene_life_ins
     */
    public String getBene_life_ins() {
        return bene_life_ins;
    }

    /**
     * Set bene_life_ins
     * @param bene_life_ins
     */
    public void setBene_life_ins(String bene_life_ins) {
        this.bene_life_ins = bene_life_ins;
    }

    /**
     * Get first name
     * @return first name
     */
    public String getEmp_fname() {
        return emp_fname;
    }

    /**
     * Set first name
     * @param emp_fname
     */
    public void setEmp_fname(String emp_fname) {
        this.emp_fname = emp_fname;
    }

    /**
     * Get street name
     * @return street name
     */
    public String getStreet() {
        return street;
    }

    /**
     * Set street name
     * @param street
     */
    public void setStreet(String street) {
        this.street = street;
    }

    /**
     * Get employee id
     * @return employee id
     */
    public String getEmp_id() {
        return emp_id;
    }

    /**
     * Set employee id
     * @param emp_id
     */
    public void setEmp_id(String emp_id) {
        this.emp_id = emp_id;
    }

    /**
     * Get SS number
     * @return SS number
     */
    public String getSs_number() {
        return ss_number;
    }

    /**
     * Set SS number
     * @param ss_number
     */
    public void setSs_number(String ss_number) {
        this.ss_number = ss_number;
    }

    /**
     * Get department id
     * @return department id
     */
    public String getDept_id() {
        return dept_id;
    }

    /**
     * Set department id
     * @param dept_id
     */
    public void setDept_id(String dept_id) {
        this.dept_id = dept_id;
    }

    /**
     * Get session token, it is
     * not used in this demo
     * @return session token
     */
    public String getToken() {
        return token;
    }

    /**
     * Set session token, it is
     * not used in this demo
     * @param token
     */
    public void setToken(String token) {
        this.token = token;
    }

    /**
     * Get status
     * @return status
     */
    public String getStatus() {
        return status;
    }

    /**
     * Set status
     * @param status
     */
    public void setStatus(String status) {
        this.status = status;
    }

    /**
     * Get salary
     * @return salary
     */
    public String getSalary() {
        return salary;
    }

    /**
     * Set salary
     * @param salary
     */
    public void setSalary(String salary) {
        this.salary = salary;
    }

    /**
     * Get Sex
     * @return sex
     */
    public String getSex() {
        return sex;
    }

    /**
     * Set sex
     * @param sex
     */
    public void setSex(String sex) {
        this.sex = sex;
    }

    /**
     * Get last name
     * @return last name
     */
    public String getEmp_lname() {
        return emp_lname;
    }

    /**
     * Set last name
     * @param emp_lname
     */
    public void setEmp_lname(String emp_lname) {
        this.emp_lname = emp_lname;
    }

    public String getTermination_date() {
        return termination_date;
    }

    public void setTermination_date(String termination_date) {
        this.termination_date = termination_date;
    }

    public String getState() {
        return state;
    }

    public void setState(String state) {
        this.state = state;
    }

    public String getBene_day_care() {
        return bene_day_care;
    }

    public void setBene_day_care(String bene_day_care) {
        this.bene_day_care = bene_day_care;
    }

    public String getStart_date() {
        return start_date;
    }

    public void setStart_date(String start_date) {
        this.start_date = start_date;
    }

    public String getManager_id() {
        return manager_id;
    }

    public void setManager_id(String manager_id) {
        this.manager_id = manager_id;
    }

    public String getBene_health_ins() {
        return bene_health_ins;
    }

    public void setBene_health_ins(String bene_health_ins) {
        this.bene_health_ins = bene_health_ins;
    }

    public String getCity() {
        return city;
    }

    public void setCity(String city) {
        this.city = city;
    }

    public String getZip_code() {
        return zip_code;
    }

    public void setZip_code(String zip_code) {
        this.zip_code = zip_code;
    }

    public String toString() {
        return getEmp_fname() + ", " + getEmp_lname();
    }
}
