/*##COPYRIGHT
 ***********************************************************************
 *       Copyright (C) 2003, by iAnywhere Solutions, Inc.              *
 *       All rights reserved. iAnywhere Solutions is a trademark       *
 *       of Sybase, Inc.  No part of this software may be              *
 *       reproduced in any form or by any means - graphic,             *
 *       electronic or mechanical, including photocopying,             *
 *       recording, taping or information storage and retrieval        *
 *       systems - except with the written permission of               *
 *       iAnywhere Solutions, Inc.                                     *
 *                                                                     *
 ***********************************************************************
#*/

package ianywhere.demo.types;

import ianywhere.demo.ui.Application;

/**
 * Created by iAnywhere Solutions
 * User: huojun
 * Date: 27-Mar-2003
 * Time: 2:34:59 PM
 */
public class Product implements XMLFriendly {
    public String color,
        description,
        size,
        quantity,
        name,
        unit_price,
        id;
    private static Product[] _products = null;

    public static Product[] getProducts() throws Exception {
        if (null == _products) {
            Application app = Application.getInstance();
            _products = app.getSoapClient().products();
        }
        return _products;
    }

    public static Product getProduct(String productId) throws Exception {
        Product[] products = getProducts();
        for (int i = 0; i < products.length; i++) {
            Product product = products[i];
            if(product.id.equalsIgnoreCase(productId)) {
                return product;
            }
        }
        return null;
    }

    /**
     * Return property names in an array,
     * these properties will go to the XML stream
     * @return an array of property names
     */
    public String[] getFriendlyFields() {
        return new String[] {
            "color","description","size","quantity"
            ,"name","unit_price","id"
        };
    }

    public String getColor() {
        return color;
    }

    public void setColor(String color) {
        this.color = color;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getSize() {
        return size;
    }

    public void setSize(String size) {
        this.size = size;
    }

    public String getQuantity() {
        return quantity;
    }

    public void setQuantity(String quantity) {
        this.quantity = quantity;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getUnit_price() {
        return unit_price;
    }

    public void setUnit_price(String unit_price) {
        this.unit_price = unit_price;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String toString() {
        return getId() + ": " + getName() + "(" + getUnit_price() + ")";
    }

    public boolean equals(Object obj) {
        if (obj instanceof Product) {
            Product product = (Product) obj;
            return id.equalsIgnoreCase(product.id);
        }
        return false;
    }
}
