/*##COPYRIGHT
 ***********************************************************************
 *       Copyright (C) 2003, by iAnywhere Solutions, Inc.              *
 *       All rights reserved. iAnywhere Solutions is a trademark       *
 *       of Sybase, Inc.  No part of this software may be              *
 *       reproduced in any form or by any means - graphic,             *
 *       electronic or mechanical, including photocopying,             *
 *       recording, taping or information storage and retrieval        *
 *       systems - except with the written permission of               *
 *       iAnywhere Solutions, Inc.                                     *
 *                                                                     *
 ***********************************************************************
#*/

package ianywhere.demo.ui;

import ianywhere.demo.types.Customer;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * Created by iAnywhere Solutions
 * User: huojun
 * Date: 28-Mar-2003
 * Time: 11:19:34 PM
 */
public class CustomerEntry extends JPanel implements UserInterface {
    private static String[] STATES = {"NJ", "NY", "PA", "TN", "IN", "CT", "NC", "PQ", "OH", "MN",
                                      "CA", "VA", "MB", "MA", "MO", "FL", "CO", "MD", "WI", "MI",
                                      "UT", "WA", "ON", "KS", "IL", "DC", "GA", "BC", "IA", "AB",
                                      "WY", "NM", "LA", "TX", "ND", "OR", };
    private JTextField _jtId = new JTextField(10);
    private JTextField _jtFname = new JTextField(15);
    private JTextField _jtLname = new JTextField(15);
    private JTextField _jtPhone = new JTextField(20);
    private JTextField _jtAddress = new JTextField(20);
    private JComboBox _jcbState = new JComboBox(STATES);
    private JTextField _jtCompany = new JTextField(20);
    private JTextField _jtZip = new JTextField(10);
    private JTextField _jtCity = new JTextField(10);

    public static void main(String[] args) {
        JFrame f = new JFrame();
        f.getContentPane().add(new CustomerEntry());
        f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        f.pack();
        f.setVisible(true);
    }

    public CustomerEntry() {
        super();
        initialize();
    }

    public void setCustomer(Customer customer) {
        _jtId.setText(customer.id);
        _jtFname.setText(customer.fname);
        _jtLname.setText(customer.lname);
        _jtAddress.setText(customer.address);
        _jtPhone.setText(customer.phone);
        _jtCity.setText(customer.city);
        _jtZip.setText(customer.zip);
        _jtCompany.setText(customer.company_name);
        _jcbState.setSelectedItem(customer.state);
    }

    private void initialize() {
        setLayout(new GridBagLayout());
        JLabel jlId = new JLabel("Id:");
        JLabel jlFname = new JLabel("First name:");
        JLabel jlLname = new JLabel("Last name:");
        JLabel jlPhone = new JLabel("Phone:");
        JLabel jlAddress = new JLabel("Address:");
        JLabel jlState = new JLabel("State:");
        JLabel jlCompany = new JLabel("Company:");
        JLabel jlZip = new JLabel("Zip:");
        JLabel jlCity = new JLabel("City:");

        // id
        GridBagConstraints c = new GridBagConstraints(1, 1, 1, 1, 0, 0, GridBagConstraints.EAST, GridBagConstraints.NONE,
                new Insets(2, 2, 2, 2), 2, 2);
        add(jlId, c);
        // id field
        c = new GridBagConstraints(2, 1, 1, 1, 0, 0, GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(2, 2, 2, 2), 2, 2);
        add(_jtId, c);
        _jtId.setEnabled(false);

        // fname
        c = new GridBagConstraints(1, 2, 1, 1, 0, 0, GridBagConstraints.EAST, GridBagConstraints.NONE,
                new Insets(2, 2, 2, 2), 2, 2);
        add(jlFname, c);
        // fname field
        c = new GridBagConstraints(2, 2, 1, 1, 0, 0, GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(2, 2, 2, 2), 2, 2);
        add(_jtFname, c);

        // lname
        c = new GridBagConstraints(1, 3, 1, 1, 0, 0, GridBagConstraints.EAST, GridBagConstraints.NONE,
                new Insets(2, 2, 2, 2), 2, 2);
        add(jlLname, c);
        // lname field
        c = new GridBagConstraints(2, 3, 1, 1, 0, 0, GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(2, 2, 2, 2), 2, 2);
        add(_jtLname, c);

        // phone
        c = new GridBagConstraints(1, 4, 1, 1, 0, 0, GridBagConstraints.EAST, GridBagConstraints.NONE,
                new Insets(2, 2, 2, 2), 2, 2);
        add(jlPhone, c);
        // phone field
        c = new GridBagConstraints(2, 4, 1, 1, 0, 0, GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(2, 2, 2, 2), 2, 2);
        add(_jtPhone, c);

        // address
        c = new GridBagConstraints(1, 5, 1, 1, 0, 0, GridBagConstraints.EAST, GridBagConstraints.NONE,
                new Insets(2, 2, 2, 2), 2, 2);
        add(jlAddress, c);
        // address field
        c = new GridBagConstraints(2, 5, 1, 1, 0, 0, GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(2, 2, 2, 2), 2, 2);
        add(_jtAddress, c);

        // state
        c = new GridBagConstraints(1, 6, 1, 1, 0, 0, GridBagConstraints.EAST, GridBagConstraints.NONE,
                new Insets(2, 2, 2, 2), 2, 2);
        add(jlState, c);
        // state field
        c = new GridBagConstraints(2, 6, 1, 1, 0, 0, GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(2, 2, 2, 2), 2, 2);
        add(_jcbState, c);

        // company
        c = new GridBagConstraints(1, 7, 1, 1, 0, 0, GridBagConstraints.EAST, GridBagConstraints.NONE,
                new Insets(2, 2, 2, 2), 2, 2);
        add(jlCompany, c);
        // company field
        c = new GridBagConstraints(2, 7, 1, 1, 0, 0, GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(2, 2, 2, 2), 2, 2);
        add(_jtCompany, c);

        // zip
        c = new GridBagConstraints(1, 8, 1, 1, 0, 0, GridBagConstraints.EAST, GridBagConstraints.NONE,
                new Insets(2, 2, 2, 2), 2, 2);
        add(jlZip, c);
        // zip field
        c = new GridBagConstraints(2, 8, 1, 1, 0, 0, GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(2, 2, 2, 2), 2, 2);
        add(_jtZip, c);

        // city
        c = new GridBagConstraints(1, 9, 1, 1, 0, 0, GridBagConstraints.EAST, GridBagConstraints.NONE,
                new Insets(2, 2, 2, 2), 2, 2);
        add(jlCity, c);
        // city field
        c = new GridBagConstraints(2, 9, 1, 1, 0, 0, GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(2, 2, 2, 2), 2, 2);
        add(_jtCity, c);

        // jbSave
        c = new GridBagConstraints(2, 11, 1, 1, 0, 0, GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(2, 2, 2, 2), 2, 2);
        JButton jbSave = new JButton("Save contact");
        jbSave.setMnemonic('S');
        add(jbSave, c);
        jbSave.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                saveCustomer();
            }
        });

        // jbNew
        c = new GridBagConstraints(1, 11, 1, 1, 0, 0, GridBagConstraints.EAST, GridBagConstraints.NONE,
                new Insets(2, 2, 2, 2), 2, 2);
        JButton jbNew = new JButton("New contact");
        jbSave.setMnemonic('N');
        add(jbNew, c);
        jbNew.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                newCustomer();
            }
        });
        setBorder(BorderFactory.createTitledBorder("Contact information"));
    }

    private void newCustomer() {
        clearFields();
    }

    private void clearFields() {
        Component[] components = getComponents();
        for (int i = 0; i < components.length; i++) {
            Component component = components[i];
            if (component instanceof JTextField) {
                JTextField jTextField = (JTextField) component;
                jTextField.setText("");
            }
        }
    }

    private Customer getCustomer() {
        Customer c = new Customer();
        c.id = _jtId.getText().trim();
        c.fname = _jtFname.getText().trim();
        c.lname = _jtLname.getText().trim();
        c.address = _jtAddress.getText().trim();
        c.phone = _jtPhone.getText().trim();
        c.city = _jtCity.getText().trim();
        c.zip = _jtZip.getText().trim();
        c.company_name = _jtCompany.getText().trim();
        c.state = (String) _jcbState.getSelectedItem();
        if (!c.isValidCustomer()) {
            JOptionPane.showMessageDialog(this, "Please fill all the fields.");
            return null;
        } else {
            return c;
        }
    }

    private void saveCustomer() {
        Customer customer = getCustomer();
        if (null != customer) {
            try {
                if (customer.id.length() == 0) {
                    Customer.addCustomer(customer);
                    _jtId.setText(customer.getId());
                    Customer.resetCustomerList();
                } else {
                    Customer.updateCustomer(customer);
                    Customer.resetCustomerList();
                }
            } catch (Exception e) {
                Application.reportException(e);
            }
        }
    }
}
