/*##COPYRIGHT
 ***********************************************************************
 *       Copyright (C) 2003, by iAnywhere Solutions, Inc.              *
 *       All rights reserved. iAnywhere Solutions is a trademark       *
 *       of Sybase, Inc.  No part of this software may be              *
 *       reproduced in any form or by any means - graphic,             *
 *       electronic or mechanical, including photocopying,             *
 *       recording, taping or information storage and retrieval        *
 *       systems - except with the written permission of               *
 *       iAnywhere Solutions, Inc.                                     *
 *                                                                     *
 ***********************************************************************
#*/

package ianywhere.demo.ui;

import ianywhere.demo.types.Customer;

import javax.swing.*;
import java.awt.*;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

/**
 * Created by iAnywhere Solutions
 * User: huojun
 * Date: 28-Mar-2003
 * Time: 4:24:16 PM
 */
public class CustomerView extends JPanel implements UserInterface {
    private ObjectTableModel _model;
    private JTable _view = new JTable(_model);
    private String[] _columnNames = {
        "phone","lname","fname","address","state",
        "company_name","zip","city","id"
    };

    public CustomerView() {
        super();
        initialize();
    }

    public void retrieve() throws Exception {
        Customer[] customers = Customer.getCustomers();
        _model = new ObjectTableModel(Customer.class,_columnNames);
        for (int i = 0; i < customers.length; i++) {
            Customer customer = customers[i];
            _model.addItem(customer);
        }
        _view.setModel(_model);
    }

    private void initialize() {
        setLayout(new BorderLayout());
        setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
        _model = new ObjectTableModel(Customer.class,_columnNames);
        _view.setRowHeight(25);
        JScrollPane jsp = new JScrollPane(_view);
        add(jsp, BorderLayout.CENTER);
        _view.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        _view.addMouseListener(new MouseAdapter() {
            public void mouseClicked(MouseEvent e) {
                if (e.getClickCount() == 2) {
                    int selectedRow = _view.getSelectedRow();
                    if (selectedRow >= 0) {
                        Customer selectedCustomer = (Customer) _model.getItem(selectedRow);
                        Application instance = Application.getInstance();
                        instance.editCustomer(selectedCustomer);
                    }
                }
            }
        });
        setBorder(BorderFactory.createTitledBorder("Customer List"));
    }
}
