/*##COPYRIGHT
 ***********************************************************************
 *       Copyright (C) 2003, by iAnywhere Solutions, Inc.              *
 *       All rights reserved. iAnywhere Solutions is a trademark       *
 *       of Sybase, Inc.  No part of this software may be              *
 *       reproduced in any form or by any means - graphic,             *
 *       electronic or mechanical, including photocopying,             *
 *       recording, taping or information storage and retrieval        *
 *       systems - except with the written permission of               *
 *       iAnywhere Solutions, Inc.                                     *
 *                                                                     *
 ***********************************************************************
#*/

package ianywhere.demo.ui;

import javax.swing.*;
import java.text.SimpleDateFormat;
import java.text.ParseException;
import java.util.Date;
import java.awt.*;

/**
 * Created by iAnywhere Solutions
 * User: huojun
 * Date: 1-Apr-2003
 * Time: 8:04:50 PM
 */
public class DateField extends JTextField {
    public static final String DATE_FORMAT_PATTERN = "yyyy-MM-dd";

    private static SimpleDateFormat _f = new SimpleDateFormat(DATE_FORMAT_PATTERN);

    public DateField() {
        super(10);
        Date date = new Date();
        setText(_f.format(date));
        setInputVerifier(new InputVerifier() {
            public boolean shouldYieldFocus(JComponent input) {
                boolean b = check(getText().trim());
                if (!b) {
                    Toolkit.getDefaultToolkit().beep();
                }
                return b;
            }

            public boolean verify(JComponent input) {
                boolean b = check(getText().trim());
                if (!b) {
                    Toolkit.getDefaultToolkit().beep();
                }
                return b;
            }
        });
    }

    public static boolean check(String text) {
        try {
            if (text.length() > 10) {
                return false;
            }
            _f.parse(text);
            char[] chars = text.toCharArray();
            for (int i = 0; i < chars.length; i++) {
                char aChar = chars[i];
                if (aChar != '-' && !Character.isDigit(aChar)) {
                    return false;
                }
            }
            return true;
        } catch (ParseException e) {
            return false;
        }
    }
}
