/*##COPYRIGHT
 ***********************************************************************
 *       Copyright (C) 2003, by iAnywhere Solutions, Inc.              *
 *       All rights reserved. iAnywhere Solutions is a trademark       *
 *       of Sybase, Inc.  No part of this software may be              *
 *       reproduced in any form or by any means - graphic,             *
 *       electronic or mechanical, including photocopying,             *
 *       recording, taping or information storage and retrieval        *
 *       systems - except with the written permission of               *
 *       iAnywhere Solutions, Inc.                                     *
 *                                                                     *
 ***********************************************************************
#*/

package ianywhere.demo.ui;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;

/**
 * Created by iAnywhere Solutions
 * User: huojun
 * Date: 27-Mar-2003
 * Time: 11:58:17 PM
 */
/**
 * A frame class which can control its minimum size
 */
public class PreferedSizeFrame extends JFrame {
    private Dimension _minSize;
    private PreferedSizeFrame _instance = this;
    private Dimension _currSize = new Dimension();

    /**
     * Constructor with minimum size setting
     * @param minSize is the preferred minimum size,
     * it can't be null
     */
    public PreferedSizeFrame(Dimension minSize) {
        super();
        _minSize = minSize;
        // add component listener to watch the minimum size
        // if the new size is smaller than minimum size
        // resize it to minimum size
        addComponentListener( new ComponentAdapter() {
            public void componentResized(ComponentEvent e) {
                if( e.getComponent() == _instance ) {
                    getSize(_currSize);
                    if( _currSize.getWidth() < _minSize.getWidth()
                    || _currSize.getHeight() < _minSize.getHeight() ) {
                        setSize(_minSize);
                    }
                }
            }
        });
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        setLocation((screenSize.width-minSize.width)/2, (screenSize.height-minSize.height)/2);
    }
}

