/*##COPYRIGHT
 ***********************************************************************
 *       Copyright (C) 2003, by iAnywhere Solutions, Inc.              *
 *       All rights reserved. iAnywhere Solutions is a trademark       *
 *       of Sybase, Inc.  No part of this software may be              *
 *       reproduced in any form or by any means - graphic,             *
 *       electronic or mechanical, including photocopying,             *
 *       recording, taping or information storage and retrieval        *
 *       systems - except with the written permission of               *
 *       iAnywhere Solutions, Inc.                                     *
 *                                                                     *
 ***********************************************************************
#*/

package ianywhere.demo.ui;

import javax.swing.*;
import javax.swing.border.Border;
import java.awt.*;

/**
 * Created by iAnywhere Solutions
 * User: huojun
 * Date: 28-Mar-2003
 * Time: 12:20:03 PM
 */
public class StatusBar extends JPanel {
    private static StatusBar _instance = new StatusBar();
    private static final String TEXT_READY = "Ready";
    private JLabel _jlText = new JLabel(TEXT_READY);

    private StatusBar() {
        super();
        Border emptyBorder = BorderFactory.createLoweredBevelBorder();
        setBorder(emptyBorder);
        setLayout(new GridBagLayout());
        GridBagConstraints c = new GridBagConstraints(1, 1, 1, 1, 1, 0, GridBagConstraints.EAST, GridBagConstraints.HORIZONTAL,
                new Insets(2, 2, 2, 2), 2, 2);
        add(_jlText,c);
    }

    public void showWaiting(String text) {
        setText(text);
        showWaiting();
    }

    public void showWaiting() {
        System.out.println("StatusBar.showWaiting");
        setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
    }

    public void close() {
        setCursor(Cursor.getDefaultCursor());
        setText(TEXT_READY);
    }

    public static StatusBar getInstance() {
        return _instance;
    }

    public void setText(String text) {
        _jlText.setText(text);
    }
}

